import { J as Json, O as ObjectStorage, L as LogHandlerOptions, dA as LogMessage, a as LogHandler, b as LogLevelAliasType, c as LoggerInterface } from './uuid-46d0b46a.js';
export { e9 as ArgumentsType, cW as AsyncMutex, de as AsyncReturnType, aa as BinInput, B as BinaryEncoder, n as CRYPTO_DEFAULT_ALG, o as CRYPTO_DEFAULT_DERIVE_ALG, p as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, dL as Channel, dK as ChannelMessageEvent, dY as CryptoEncoder, aP as DAY_MS, bc as Day, aR as DayInput, bb as DayInputLegacy, aQ as DayValue, bi as DecimalInput, bh as DecimalValue, dR as DefaultListener, dp as DefaultLogger, br as Difference, bq as DifferenceType, cM as Disposable, cL as Disposer, cK as DisposerFunction, dS as Emitter, dP as EmitterAllHandler, dO as EmitterHandler, dV as Encoder, bO as FilterFunction, dX as JsonEncoder, dQ as ListenerSignature, dM as LocalChannel, dq as LogLevel, dy as LogLevelAlias, dz as LogLevelAliasKey, dr as LogLevelAll, ds as LogLevelDebug, dv as LogLevelError, dw as LogLevelFatal, dt as LogLevelInfo, dx as LogLevelOff, du as LogLevelWarn, dE as LoggerConsoleHandler, dC as LoggerContext, dB as LoggerContextInterface, dJ as LoggerMemoryHandler, bP as MapperFunction, eu as MemStorage, et as MemStorageOptions, d$ as Message, dZ as MessageAction, e3 as MessageDefinitions, e4 as MessageHub, d_ as MessageResult, e1 as MessagesDefaultMethods, e2 as MessagesMethods, e0 as MessagesOptions, cV as Mutex, eA as NestedArray, dW as NoopEncoder, c_ as PoolConfig, d1 as PoolTask, d2 as PoolTaskEvents, c$ as PoolTaskFn, cZ as PoolTaskIdConflictResolution, d0 as PoolTaskState, bv as Primitive, d4 as Progress, e7 as PubSub, ec as RPCFn, eb as RPCOptions, ed as RPCReturn, aG as RenderMessagesOptions, ea as ReturnType, cc as RoundingMode, dh as SerialQueue, cn as SortableItem, dg as TaskEvents, df as TaskFn, aO as Uint8ArrayToDataUri, aq as Uint8ArrayToHexDump, ap as Uint8ArrayToJson, ae as Uint8ArrayToString, cR as UseDefer, cO as UseDispose, cJ as XRX, ac as _decodeUtf8Polyfill, ab as _encodeUtf8Polyfill, $ as _useBase, Y as arrayAvg, Z as arrayBatches, M as arrayEmptyInPlace, I as arrayFilterInPlace, D as arrayFlatten, E as arrayIntersection, Q as arrayIsEqual, V as arrayMax, W as arrayMin, z as arrayMinus, U as arrayRandomElement, G as arrayRemoveElement, H as arraySetElement, S as arrayShuffle, T as arrayShuffleForce, R as arrayShuffleInPlace, N as arraySorted, P as arraySortedNumbers, X as arraySum, F as arraySymmetricDifference, K as arrayToggleInPlace, A as arrayUnion, y as arrayUnique, d as assert, e as assertCondition, b$ as avg, bZ as between, k as bitfield, l as blobToArrayBuffer, aN as blobToDataUri, m as blobToUint8Array, dD as browserSelectColorByName, cD as cloneJsonObject, cC as cloneObject, c8 as cmp, c7 as composeOrderby, _ as createArray, j as createBinaryStreamDecoder, i as createBinaryStreamEncoder, dN as createLocalChannelPair, d5 as createPromise, e5 as createPromiseProxy, w as csvParse, x as csvParseToObjects, v as csvStringify, aM as dataUriToBlob, aL as dataUriToMimeType, aK as dataUriToUint8Array, bg as dateStringToDays, bf as day, aU as dayDay, b8 as dayDiff, aY as dayFromAny, a_ as dayFromDate, a$ as dayFromDateGMT, b3 as dayFromParts, b4 as dayFromString, b1 as dayFromTimestamp, aX as dayFromToday, ba as dayIterator, aT as dayMonth, b5 as dayMonthStart, b7 as dayOffset, b9 as dayRange, aW as dayToDate, aZ as dayToDateGMT, aV as dayToParts, b2 as dayToString, b0 as dayToTimestamp, aS as dayYear, b6 as dayYearStart, dj as debounce, bj as decimal, bm as decimalCentsPart, bk as decimalFromCents, bl as decimalToCents, a4 as decodeBase16, a2 as decodeBase32, a6 as decodeBase58, a8 as decodeBase62, h as decodeJson, u as decrypt, bn as deepEqual, bp as deepMerge, bo as deepStripUndefinedInPlace, s as deriveKeyPbkdf2, eq as detect, bs as diffObjects, q as digest, ez as duration, cB as empty, a3 as encodeBase16, a1 as encodeBase32, a5 as encodeBase58, a7 as encodeBase62, g as encodeJson, cv as encodeQuery, t as encrypt, cp as endSortWeight, cx as ensureKey, cy as ensureKeyAsync, an as equalBinary, bt as escapeHTML, cb as escapeRegExp, a9 as estimateSizeForBase, f as fatal, eh as fetchBasic, ei as fetchJson, em as fetchOptionsBasicAuth, ek as fetchOptionsFormURLEncoded, el as fetchOptionsJson, ej as fetchText, aJ as fixBrokenUth8String, bd as forEachDay, cG as forTimes, aH as formatMessages, ew as formatMilliseconds, al as fromBase64, am as fromBase64String, au as fromCamelCase, ai as fromHex, ep as getGlobal, dk as getGlobalContext, dT as getGlobalEmitter, dm as getGlobalLogger, dn as getGlobalLoggerIfExists, dF as getNamespaceFilterString, eo as getNavigator, ey as getPerformanceTimestamp, bU as getSecureRandom, bV as getSecureRandomIfPossible, ev as getTimestamp, en as getWindow, ef as httpMethod, d7 as immediate, by as isArray, bF as isBoolean, er as isBrowser, ce as isEven, cd as isHalf, bD as isInteger, dl as isLocalHost, bJ as isNotNull, bH as isNull, bG as isNullOrUndefined, bC as isNumber, bw as isObject, c1 as isPrime, c0 as isPrimeRX, bx as isPrimitive, dc as isPromise, bz as isRecord, bA as isRecordPlain, bE as isSafeInteger, bB as isString, d9 as isTimeout, bI as isUint8Array, bK as isValue, ag as joinToUint8Array, bN as jsonStringify, bM as jsonStringifySafe, bL as jsonStringifySorted, ao as jsonToUint8Array, cA as last, dU as lazyListener, ct as linkifyPlainText, bS as listDistinctUnion, bR as listGroupBy, bT as listOfKey, bQ as listQuery, cE as memoize, cF as memoizeAsync, cq as moveSortWeight, eB as noop, c5 as objectIsEmpty, c3 as objectMap, c4 as objectMergeDisposable, eg as parseBasicAuth, ex as parseDate, dH as parseLogLevel, c6 as parseOrderby, cw as parseQuery, dd as promisify, eX as qid, bW as randomBoolean, bY as randomFloat, bX as randomInt, r as randomUint8Array, cI as regExpEscape, cH as regExpString, aI as renderMessages, cg as roundDown, cj as roundHalfAwayFromZero, ck as roundHalfDown, cl as roundHalfEven, ci as roundHalfOdd, cm as roundHalfTowardsZero, ch as roundHalfUp, cf as roundUp, c2 as seededRandom, eR as setUuidDefaultEncoding, cz as size, d6 as sleep, cr as sortedItems, c9 as sortedOrderby, co as startSortWeight, av as stringToBoolean, ax as stringToFloat, aw as stringToInteger, ad as stringToUInt8Array, eN as suid, eM as suidBytes, eP as suidBytesDate, eO as suidDate, b_ as sum, di as throttle, d8 as timeout, aj as toBase64, ak as toBase64Url, aF as toBool, ar as toCamelCase, as as toCapitalize, at as toCapitalizeWords, aC as toFloat, ah as toHex, cu as toHumanReadableUrl, aD as toInt, aE as toString, af as toUint8Array, ca as toValidFilename, be as today, da as tryTimeout, eW as uname, bu as unescapeHTML, cY as useAsyncMutex, a0 as useBase, cQ as useDefer, cN as useDispose, cP as useDisposer, cU as useEventListener, es as useExitHandler, cT as useInterval, dI as useLevelFilter, e6 as useMessageHub, cX as useMutex, dG as useNamespaceFilter, d3 as usePool, e8 as usePubSub, ee as useRPC, cs as useSorted, cS as useTimeout, eS as uuid, eQ as uuid32bit, eG as uuidB32, eD as uuidB62, eC as uuidBytes, eT as uuidDecode, eI as uuidDecodeB32, eF as uuidDecodeB62, eL as uuidDecodeV4, eU as uuidEncode, eH as uuidEncodeB32, eE as uuidEncodeB62, eK as uuidEncodeV4, eV as uuidIsValid, eJ as uuidv4, ay as valueToBoolean, aA as valueToFloat, az as valueToInteger, aB as valueToString, db as waitOn } from './uuid-46d0b46a.js';
import * as fs from 'fs';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare function setupWebCrypto(): void;
declare function getWebCrypto(): Promise<Crypto>;

interface csvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

declare function getStat(path: string): fs.Stats | undefined;
declare function getFingerprint(path: string): string;
declare function walkSync(rootFolder: string, subFolder?: string, ignoreHidden?: boolean): string[];
declare function files(opt?: {
    basePath?: string;
    pattern?: string | RegExp;
    filter?: (name: string) => boolean;
    ignoreHidden?: boolean;
}): string[];

declare function getStatAsync(path: string): Promise<fs.Stats | undefined>;
declare function getFingerprintAsync(path: string): Promise<string>;
declare function walkSyncAsync(rootFolder: string, subFolder?: string, ignoreHidden?: boolean): Promise<string[]>;
declare function filesAsync(opt?: {
    basePath?: string;
    pattern?: string | RegExp;
    filter?: (name: string) => boolean;
    ignoreHidden?: boolean;
}): Promise<string[]>;

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function isHiddenPath(path: string): boolean;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function globToRegExp(glob: string, opts?: any): RegExp;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): string[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

declare function Logger(name?: string, level?: LogLevelAliasType): LoggerInterface;

export { FileStorage, FileStorageOptions, Json, LogHandler, LogHandlerOptions, LogLevelAliasType, LogMessage, Logger, LoggerFileHandler, LoggerInterface, LoggerNodeHandler, ObjectStorage, colorString, colorStringList, ensureFolder, exists, files, filesAsync, getEnvVariableRelaxed, getFingerprint, getFingerprintAsync, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, getStat, getStatAsync, getWebCrypto, globToRegExp, isHiddenPath, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, setupWebCrypto, stringToPath, toHumanReadableFilePath, toPath, valueToPath, walkSync, walkSyncAsync, writeText };
